oe-buildenv-internal 4.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136
  1. #!/bin/sh
  2. # OE-Core Build Environment Setup Script
  3. #
  4. # Copyright (C) 2006-2011 Linux Foundation
  5. #
  6. # This program is free software; you can redistribute it and/or modify
  7. # it under the terms of the GNU General Public License as published by
  8. # the Free Software Foundation; either version 2 of the License, or
  9. # (at your option) any later version.
  10. #
  11. # This program is distributed in the hope that it will be useful,
  12. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  13. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  14. # GNU General Public License for more details.
  15. #
  16. # You should have received a copy of the GNU General Public License
  17. # along with this program; if not, write to the Free Software
  18. # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  19. if ! $(return >/dev/null 2>&1) ; then
  20. echo 'oe-buildenv-internal: error: this script must be sourced'
  21. echo ''
  22. echo 'Usage: . $OEROOT/scripts/oe-buildenv-internal &&'
  23. echo ''
  24. echo 'OpenEmbedded oe-buildenv-internal - an internal script that is'
  25. echo 'used in oe-init-build-env to initialize oe build environment'
  26. echo ''
  27. exit 2
  28. fi
  29. # It is assumed OEROOT is already defined when this is called
  30. if [ -z "$OEROOT" ]; then
  31. echo >&2 "Error: OEROOT is not defined!"
  32. return 1
  33. fi
  34. if [ -z "$OE_SKIP_SDK_CHECK" ] && [ -n "$OECORE_SDK_VERSION" ]; then
  35. echo >&2 "Error: The OE SDK/ADT was detected as already being present in this shell environment. Please use a clean shell when sourcing this environment script."
  36. return 1
  37. fi
  38. # Make sure we're not using python v3.x as 'python', we don't support it.
  39. py_v2_check=$(/usr/bin/env python --version 2>&1 | grep "Python 3")
  40. if [ -n "$py_v2_check" ]; then
  41. echo >&2 "OpenEmbedded requires 'python' to be python v2 (>= 2.7.3), not python v3."
  42. echo >&2 "Please set up python v2 as your default 'python' interpreter."
  43. return 1
  44. fi
  45. unset py_v2_check
  46. py_v27_check=$(python -c 'import sys; print sys.version_info >= (2,7,3)')
  47. if [ "$py_v27_check" != "True" ]; then
  48. echo >&2 "OpenEmbedded requires 'python' to be python v2 (>= 2.7.3), not python v3."
  49. echo >&2 "Please upgrade your python v2."
  50. fi
  51. unset py_v27_check
  52. # We potentially have code that doesn't parse correctly with older versions
  53. # of Python, and rather than fixing that and being eternally vigilant for
  54. # any other new feature use, just check the version here.
  55. py_v34_check=$(python3 -c 'import sys; print(sys.version_info >= (3,4,0))')
  56. if [ "$py_v34_check" != "True" ]; then
  57. echo >&2 "BitBake requires Python 3.4.0 or later as 'python3'"
  58. return 1
  59. fi
  60. unset py_v34_check
  61. if [ -z "$BDIR" ]; then
  62. if [ -z "$1" ]; then
  63. BDIR="build"
  64. else
  65. BDIR="$1"
  66. if [ "$BDIR" = "/" ]; then
  67. echo >&2 "Error: / is not supported as a build directory."
  68. return 1
  69. fi
  70. # Remove any possible trailing slashes. This is used to work around
  71. # buggy readlink in Ubuntu 10.04 that doesn't ignore trailing slashes
  72. # and hence "readlink -f new_dir_to_be_created/" returns empty.
  73. BDIR=$(echo $BDIR | sed -re 's|/+$||')
  74. BDIR=$(readlink -f "$BDIR")
  75. if [ -z "$BDIR" ]; then
  76. PARENTDIR=$(dirname "$1")
  77. echo >&2 "Error: the directory $PARENTDIR does not exist?"
  78. return 1
  79. fi
  80. fi
  81. if [ -n "$2" ]; then
  82. BITBAKEDIR="$2"
  83. fi
  84. fi
  85. if [ "${BDIR#/}" != "$BDIR" ]; then
  86. BUILDDIR="$BDIR"
  87. else
  88. BUILDDIR="$(pwd)/$BDIR"
  89. fi
  90. unset BDIR
  91. if [ -z "$BITBAKEDIR" ]; then
  92. BITBAKEDIR="$OEROOT/bitbake$BBEXTRA"
  93. fi
  94. BITBAKEDIR=$(readlink -f "$BITBAKEDIR")
  95. BUILDDIR=$(readlink -f "$BUILDDIR")
  96. if [ ! -d "$BITBAKEDIR" ]; then
  97. echo >&2 "Error: The bitbake directory ($BITBAKEDIR) does not exist! Please ensure a copy of bitbake exists at this location or specify an alternative path on the command line"
  98. return 1
  99. fi
  100. # Make sure our paths are at the beginning of $PATH
  101. for newpath in "$BITBAKEDIR/bin" "$OEROOT/scripts"; do
  102. # Remove any existences of $newpath from $PATH
  103. PATH=$(echo $PATH | sed -re "s#(^|:)$newpath(:|$)#\2#g;s#^:##")
  104. # Add $newpath to $PATH
  105. PATH="$newpath:$PATH"
  106. done
  107. unset BITBAKEDIR newpath
  108. # Used by the runqemu script
  109. export BUILDDIR
  110. export PATH
  111. BB_ENV_EXTRAWHITE_OE="MACHINE DISTRO TCMODE TCLIBC HTTP_PROXY http_proxy \
  112. HTTPS_PROXY https_proxy FTP_PROXY ftp_proxy FTPS_PROXY ftps_proxy ALL_PROXY \
  113. all_proxy NO_PROXY no_proxy SSH_AGENT_PID SSH_AUTH_SOCK BB_SRCREV_POLICY \
  114. SDKMACHINE BB_NUMBER_THREADS BB_NO_NETWORK PARALLEL_MAKE GIT_PROXY_COMMAND \
  115. SOCKS5_PASSWD SOCKS5_USER SCREENDIR STAMPS_DIR BBPATH_EXTRA BB_SETSCENE_ENFORCE"
  116. BB_ENV_EXTRAWHITE="$(echo $BB_ENV_EXTRAWHITE $BB_ENV_EXTRAWHITE_OE | tr ' ' '\n' | LC_ALL=C sort --unique | tr '\n' ' ')"
  117. export BB_ENV_EXTRAWHITE